# Scripts d'automatisation de cloture mensuelle

## Installation

Les scripts ont été développés sous R version 3.3.1, à l'aide des packages suivants :

* Versions stables (CRAN)
  * tidyr 0.5.1
  * ggplot2 2.1.0
  * lubridate 1.5.6
  * rvest 0.3.2
  * stringr 1.0.0
  * readr 0.2.2
  * magrittr 1.5
  * dplyr 0.5.0
  * knitr 1.13
  * rmarkdown 1.0
  * htmlwidgets 0.7

* Versions de développement (github)
  * DT 0.1.57

Ces paquets sont installés au niveau système pour tous les utilisateurs livenne.

## Utilisation

La génération du rapport est séparée en deux parties :
* l'acquisition et le pré-traitement des données
* la génération du rapport en lui-même

### Acquisition des données

Une première étape manuelle consiste à utiliser la requête Business Objects **exhaustivite.wid** présente dans le répertoire et de sauvegarder le fichier csv (choisir les options de format : encodage en UTF8, séparateur = ",") sous le nom **exhau_pims.csv** dans le répertoire du script.

Le script **donnees.sh** appelle le script **donnees.R** qui récupère les autres données depuis les différentes sources (base de données MySQL (tables fix116, fix117, mvt_gam et structure) sur livenne et données ePMSI sur le site de l'ATIH, exhaustivité WebBIMS dans le fichier **exhau_pims.csv**, tableaux ePMSI CCEG+CHU de 2015 pré-assemblés dans le fichier **Ovalide.Rdata** (nécessaires uniquement pour les bilans de 2016).
Les tableaux ePMSI sont archivés dans le dossier **ePMSI**.

Il nécessite un appel en ligne de commande avec les paramètres suivants :
* nom d'utilisateur de session CHU
* mot de passe de session CHU (pour passer à travers le proxy)

* nom d'utilisateur ePMSI
* mot de passe ePMSI (pour télécharger les tableaux depuis ePMSI)

* nom d'utilisateur MySQL livenne
* mot de passe MySQL livenne (pour interroger la base de données)

* annee de la clôture
* mois de la clôture

Un appel incorrect au script rappelle les paramètres de ligne de commande à utiliser.
Les noms d'utilisateurs/mots de passe contenant des caractères spéciaux (autres qu'alphanumériques) doivent être entourés de guillemets.

Le script **donnees.R** utilise le fichier **Ovalide.Rdata** contenant les données fusionnées du CHU et du CCEG pour 2015. Après 2016 ce fichier ne sera plus utile. Il utilise également le fichier **exhau.Rdata** pour sauvegarder les données d'exhaustivité depuis le début de l'année en cours. Ce fichier est réinitialisé en début d'année.

Les données récupérées et pré-traitées son enregistrées dans le fichier **donnees.Rdata** pour l'utilisation par le script de génération du rapport.

Le fichier **gam.csv** est généré. Il contient les séjours présents dans la base de mouvements (GAM), mais qui n'ont ni été envoyés à l'ATIH, ni sont connus comme étant non exhaustifs dans WebPIMS. Il s'agit principalement d'erreurs de la base GAM (annulations, transformations) à corriger.

### Génération du rapport

Le script **render.sh** appelle la commande *render* de Rmarkdown pour générer le rapport de clôture **cloture.html** à partir du fichier **cloture.Rmd**.
Celui-ci génère les différents tableaux et figures à la volée à partir des données pré-traitées fournies par **donnees.R** dans le fichier **donnees.Rdata**.

Le fichier **cloture.html** généré peut être vérifié avant publication. La publication se fait en copiant le fichier dans le répertoire au-dessus dans l'arborescence (/var/www/html/cloture).
Ce fichier doit également être copié dans le répertoire **archive** sous la forme **cloture*ANNEE_MOIS*.html** pour archivage.

![](README.png)
